//<#!@READ-ONLY-SECTION-START@!#>
/*!
 * \class cfm_betterfunction
 * \brief Intel(R) CoFluent(TM) Studio - Intel Corporation
 * \details Simulation model of AIC_MU_ProjectApp generated by C++ Generator for SystemC/TLM2
 */

#ifndef COFS_MODEL_AIC_MU_PROJECTAPP_BETTERFUNCTION
#define COFS_MODEL_AIC_MU_PROJECTAPP_BETTERFUNCTION

#include "cfm_aic_mu_projectapp_global.h"
#include "cfm_aic_mu_projectapp_global_types.h"
#include "cofluent.h"

#include "dp/cfm_betterfunction_dp_if.h"
//<#!@READ-ONLY-SECTION-END@!#>
//Start of 'BetterFunction includes' algorithm generated code

//End of 'BetterFunction includes' algorithm generated code
//<#!@READ-ONLY-SECTION-START@!#>

///    \defgroup dxgBetterFunction Function BetterFunction
//@{
///        \page dxpBetterFunction
//@{
///    \brief BetterFunction function model.
class cfm_betterfunction: public cf_core::cf_function,
		public cfm_betterfunction_dp_if {
public:
	SC_HAS_PROCESS (cfm_betterfunction);

	/// constructor
	cfm_betterfunction(sc_core::sc_module_name name);

	/// destructor
	virtual ~cfm_betterfunction(void);
	virtual void cb_before_elaboration(void);

protected:
	/// initialize attributes
	void cb_init_attributes(void);
	/// initialize definitions
	void cb_init_local_vars(void);

	/// behavior
	void cfm_behavior();
	/// bestOperation operation
	void cfm_op_bestOperation();
	/// init operation
	void cfm_op_init();

protected:
	/// \name operations
	//@{
	cf_core::cf_operation bestOperation;
	cf_core::cf_operation init;
	//@}

	/// \name user-defined local declarations
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'BetterFunction local declarations' algorithm generated code

	//End of 'BetterFunction local declarations' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>

};

//@}
//@}
#endif // COFS_MODEL_AIC_MU_PROJECTAPP_BETTERFUNCTION

//<#!@READ-ONLY-SECTION-END@!#>